--[[
attachableService
Specialization for serivce of a tool that must be turned on to work

@author:  	Ifko[nator]
@date:		15.04.2014
@version:	v1.0
@history:	v1.0 - initial implementation

Funktioniert bei: Pressen, Ladewagen, Schwader, Zetter .. Eigendlich bei jedem Gerät, das man anschalten muss. Bei Grubbern würde dieses Script zum Beispiel nicht funktionieren.
--------------------------------------------------------------------------------------------------
Alternativer XML Code: (Wenn man die Servicepreise, Preisunterschiede oder Serviceintervalle auf einen anderen Grundwert legen will.) Kann man aber auch ohne bedenken aus der XML rauslassen.

	<attachableService>	
		<attachableBigService Price="1568" TimeInterval="13" PriceRefresherMin="301" PriceRefresherMax="2579" isActive="true" />
		<attachableSmallService Price="341" TimeInterval="8" PriceRefresherMin="158" PriceRefresherMax="1289" isActive="true" />
		<attachableInspektion Price="205" TimeInterval="14.2" PriceRefresherMin="68" PriceRefresherMax="157" isActive="true" />
	</attachableService>

Kommastellen sind bei 'Price', 'PriceRefresherMin' und 'PriceRefresherMax' keine Erlaubt. Im LS gibt es ja immer nur ganze Euro und keine Cent. Was ich etwas Schade find, aber naja.. ^^ 

'PriceRefresherMin' und 'PriceRefresherMax' geben an, wieviel Euro mindestens oder maximal zu den Wert von 'Price' addiert werden. 
Steht nun bei 'PriceRefresherMin' "50" und bei 'PriceRefresherMax' "100", kann immer eine Zahl von 50 bis 100 dazu addiert werden. Welche das nun schlussendlich ist, weiß man nie.. ^^ Das ist dann "Zufall"...

Setzt man den Wert bei 'isActive' auf "false", dann ist das entsprechende Service oder die Inspektion, inaktiv. Nützlich wenn man einen oder zwei Intervalle nicht nutzen möchte.

Bei 'TimeInterval' sind Kommastellen erlaubt. Die Zeit bei 'TimeInterval' ist Real Time, egal mit welcher Zeitskalierung man spielt.

Beispiele:

TimeInterval="8" = 8 Stunden
TimeInterval="0.1" = 6 Minuten
TimeInterval="0.5" = 30 Minuten
TimeInterval="14.1" = 14 Stunden und 6 Minuten
TimeInterval="13.5" = 13 Stunden und 30 Minuten
TimeInterval="13.55" = 13 Stunden und 33 Minuten
--------------------------------------------------------------------------------------------------
modDesc: (Diese Einträge sind Pflicht in der modDesc!)

	<l10n>
		<text name="BIG_SERVICE"><de>Das große Service wird Sie %d€ kosten! Sie können erst weiter arbeiten, wenn das Service durchgeführt wurde!</de><en>Das große Service wird Sie %d€ kosten! Sie können erst weiter arbeiten, wenn das Service durchgeführt wurde!</en></text>
		<text name="SMALL_SERVICE"><de>Das kleine Service wird Sie %d€ kosten! Sie können erst weiter arbeiten, wenn das Service durchgeführt wurde!</de><en>Das kleine Service wird Sie %d€ kosten! Sie können erst weiter arbeiten, wenn das Service durchgeführt wurde!</en></text>
		<text name="SERVICE_BUTTON"><de>Service durchführen</de><en>Service durchführen</en></text>
		<text name="INSPEKTION"><de>Die Inspektion wird Sie %d€ kosten! Sie können erst weiter arbeiten, wenn die Inspektion durchgeführt wurde!</de><en>Inspektion fällig! Die Inspektion wird Sie %d€ kosten! Sie können erst weiter arbeiten, wenn die Inspektion durchgeführt wurde!</en></text>
		<text name="INSPEKTION_BUTTON"><de>Inspektion durchführen</de><en>Inspektion durchführen</en></text>
		<text name="MECHANIKER_BIG_SERVICE"><de>Großes Service steht bevor. Lassen Sie den Mechaniker den Ladewagen überprüfen. [Taste bitte halten bis das Service durchgeführt wurde.]</de><en>Großes Service steht bevor. Lassen Sie den Mechaniker den Ladewagen überprüfen. [Taste bitte halten bis das Service durchgeführt wurde.]</en></text>
		<text name="MECHANIKER_SMALL_SERVICE"><de>Kleines Service steht bevor. Lassen Sie den Mechaniker den Ladewagen überprüfen. [Taste bitte halten bis das Service durchgeführt wurde.]</de><en>Kleines Service steht bevor. Lassen Sie den Mechaniker den Ladewagen überprüfen. [Taste bitte halten bis das Service durchgeführt wurde.]</en></text>
		<text name="MECHANIKER_INSPEKTION"><de>Inspektion steht bevor. Lassen Sie den Mechaniker den Ladewagen überprüfen. [Taste bitte halten bis die Inspektion durchgeführt wurde.]</de><en>Inspektion steht bevor. Lassen Sie den Mechaniker den Ladewagen überprüfen. [Taste bitte halten bis die Inspektion durchgeführt wurde.]</en></text>
		<text name="MECHANIKER_BUTTON"><de>Mechaniker den Ladewagen überprüfen lassen</de><en>Mechaniker den Ladewagen überprüfen lassen</en></text>
	</l10n>
	
	<inputBindings>
		<input name="SERVICE_BUTTON" category="VEHICLE" key1="KEY_KP_0" key2="" button="" device="0" mouse="" />
		<input name="MECHANIKER_BUTTON" category="VEHICLE" key1="KEY_o" key2="" button="" device="0" mouse="" />
	</inputBindings>

INFO:
Ein VehicleType sollte in der modDesc schon vorhanden sein, sonst wirds etwas schwerer..

	<specializations>
		<specialization name="attachableService" className="attachableService" filename="Scripts/attachableService.lua"/>	
	</specializations>

Den Pfad bei 'filename' zur attachableService.lua gegebenenfalls anpassen!

	<vehicleTypes>
	  <type name="NAME des VehicleTypes (Ist von Mod zu Mod unterschiedlich)" className="Vehicle" filename="$dataS/scripts/vehicles/Vehicle.lua">
		<specialization name="attachableService" />
	  </type>
	</vehicleTypes>

ACHTUNG!:
Beim VehicleType müssen auch noch andere specializations stehen! Diese können von Mod zu Mod unterschiedlich sein. Daher ist es einfacher, wenn ihr einen Mod habt, der einen VehicleType schon fertig eingetragen hat.

Für fragen bin ich via PN: 
auf http://www.ls-mapsource.de als "Ifko" 
oder auf http://www.modding-welt.com als "Ifkonator" zu erreichen.
]]

attachableService = {};

function attachableService.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function attachableService:load(xmlFile)
	self.attachableBigService = false;
	self.attachableBigServiceWarning = false;
	self.attachableBigServiceMechaniker = false;
	self.attachableBigServiceTime = 0;
	self.attachableBigServiceTimeInterval = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableBigService#TimeInterval"), 10.5);
	self.attachableBigServicePrice = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableBigService#Price"), 1960);
	self.attachableBigServiceActive = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.attachableService.attachableBigService#isActive"), true);
	self.priceRefresherBigMin = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableBigService#PriceRefresherMin"), 200);
	self.priceRefresherBigMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableBigService#PriceRefresherMax"), 1853);
	self.priceRefresherBig = 0;
	self.addAttachableServiceTimeBig = SpecializationUtil.callSpecializationsFunction("addAttachableServiceTimeBig");
	
	self.attachableSmallService = false;
	self.attachableSmallServiceWarning = false;
	self.attachableSmallServiceMechaniker = false;
	self.attachableSmallServiceTime = 0;
	self.attachableSmallServiceTimeInterval = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableSmallService#TimeInterval"), 7.5);
	self.attachableSmallServicePrice = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableSmallService#Price"), 850);
	self.attachableSmallServiceActive = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.attachableService.attachableSmallService#isActive"), true);
	self.priceRefresherSmallMin = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableSmallService#PriceRefresherMin"), 100);
	self.priceRefresherSmallMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableSmallService#PriceRefresherMax"), 131);
	self.priceRefresherSmall = 0;
	self.addAttachableServiceTimeSmall = SpecializationUtil.callSpecializationsFunction("addAttachableServiceTimeSmall");
	
	self.attachableInspektion = false;
	self.attachableInspektionWarning = false;
	self.attachableInspektionMechaniker = false;
	self.attachableInspektionTime = 0;
	self.attachableInspektionTimeInterval = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableInspektion#TimeInterval"), 12);
	self.attachableInspektionPrice = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableInspektion#Price"), 500);
	self.attachableInspektionActive = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.attachableService.attachableInspektion#isActive"), true);
	self.priceRefresherInspektionMin = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableInspektionService#PriceRefresherMin"), 50);
	self.priceRefresherInspektionMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.attachableService.attachableInspektionService#PriceRefresherMax"), 108);
	self.priceRefresherInspektion = 0;
	self.addAttachableServiceTimeInspektion = SpecializationUtil.callSpecializationsFunction("addAttachableServiceTimeInspektion");
	
	self.setPrice = false;
	
	self.setPriceToPay = SpecializationUtil.callSpecializationsFunction("setPriceToPay");
end;

function attachableService:delete()
end;

function attachableService:readStream(streamId, connection)
	self:addAttachableServiceTimeBig(streamReadFloat32(streamId), true);
	self:addAttachableServiceTimeSmall(streamReadFloat32(streamId), true);
	self:addAttachableServiceTimeInspektion(streamReadFloat32(streamId), true);
end;

function attachableService:writeStream(streamId, connection)
	streamWriteFloat32(streamId, self.attachableBigServiceTime);
	streamWriteFloat32(streamId, self.attachableSmallServiceTime);
	streamWriteFloat32(streamId, self.attachableInspektionTime);
end;

function attachableService:mouseEvent(posX, posY, isDown, isUp, button)
end;

function attachableService:keyEvent(unicode, sym, modifier, isDown)
end;

function attachableService:update(dt)
	if self:getIsActive() then
		self:setPriceToPay();
		self.setPrice = true;
		if self.attachableBigService then
			self:setIsTurnedOn(false);
			self.attachableBigServiceMechaniker = true;
			self.setPrice = false;
			if InputBinding.isPressed(InputBinding.MECHANIKER_BUTTON) then
				self.setPrice = false;
				self.attachableBigServiceWarning = true;
				self.attachableBigServiceMechaniker = false;
				if InputBinding.hasEvent(InputBinding.SERVICE_BUTTON) then
					self.setPrice = false;
					g_currentMission:addSharedMoney(-(self.attachableBigServicePrice+self.priceRefresherBig));
					self:setIsTurnedOn(true);
					self.attachableBigServiceWarning = false;
					self.attachableBigService = false;
					self.attachableBigServiceTime = 0;
				end;
			end;
		elseif self.attachableSmallService then
			self:setIsTurnedOn(false);
			self.attachableSmallServiceMechaniker = true;
			self.setPrice = false;
			if InputBinding.isPressed(InputBinding.MECHANIKER_BUTTON) then
				self.setPrice = false;
				self.attachableSmallServiceWarning = true;
				self.attachableSmallServiceMechaniker = false;
				if InputBinding.hasEvent(InputBinding.SERVICE_BUTTON) then
					self.setPrice = false;
					g_currentMission:addSharedMoney(-(self.attachableSmallServicePrice+self.priceRefresherSmall));
					self:setIsTurnedOn(true);
					self.attachableSmallServiceWarning = false;
					self.attachableSmallService = false;
					self.attachableSmallServiceTime = 0;
				end;
			end;
		elseif self.attachableInspektion then
			self:setIsTurnedOn(false);
			self.attachableInspektionMechaniker = true;
			self.setPrice = false;
			if InputBinding.isPressed(InputBinding.MECHANIKER_BUTTON) then
				self.setPrice = false;
				self.attachableInspektionWarning = true;
				self.attachableInspektionMechaniker = false;
				if InputBinding.hasEvent(InputBinding.SERVICE_BUTTON) then
					self.setPrice = false;
					g_currentMission:addSharedMoney(-(self.attachableInspektionPrice+self.priceRefresherInspektion));
					self:setIsTurnedOn(true);
					self.attachableInspektionWarning = false;
					self.attachableInspektion = false;
					self.attachableInspektionTime = 0;
				end;
			end;
		end;
	end;
end;

function attachableService:updateTick(dt)
    if self.isTurnedOn then 
		self:addAttachableServiceTimeBig(dt);
		self:addAttachableServiceTimeSmall(dt);
		self:addAttachableServiceTimeInspektion(dt);
	end;
	
	if self.attachableBigServiceActive and self.attachableBigServiceTime > (self.attachableBigServiceTimeInterval * 1000 * 60 * 60) then
		self.attachableBigService = true
	elseif self.attachableSmallServiceActive and self.attachableSmallServiceTime > (self.attachableSmallServiceTimeInterval * 1000 * 60 * 60) then
		self.attachableSmallService = true
	elseif self.attachableInspektionActive and self.attachableInspektionTime > (self.attachableInspektionTimeInterval * 1000 * 60 * 60) then
		self.attachableInspektion = true
	end;
end;

function attachableService:setPriceToPay()
	if self.setPrice then
		self.priceRefresherBig = math.random(self.priceRefresherBigMin, self.priceRefresherBigMax);
		self.priceRefresherSmall = math.random(self.priceRefresherSmallMin, self.priceRefresherSmallMax);
		self.priceRefresherInspektion = math.random(self.priceRefresherInspektionMin, self.priceRefresherInspektionMax);
	end;
end;

function attachableService:draw()
	if self.attachableBigServiceMechaniker then
		g_currentMission:addWarning(g_i18n:getText("MECHANIKER_BIG_SERVICE"), 0.040, 0.035);
		g_currentMission:addHelpButtonText(g_i18n:getText("MECHANIKER_BUTTON"), InputBinding.MECHANIKER_BUTTON);
	elseif self.attachableBigServiceWarning then
		g_currentMission:addWarning(string.format(g_i18n:getText("BIG_SERVICE"), self.attachableBigServicePrice + self.priceRefresherBig), 0.040, 0.035);
		g_currentMission:addHelpButtonText(g_i18n:getText("SERVICE_BUTTON"), InputBinding.SERVICE_BUTTON);
	elseif self.attachableSmallServiceMechaniker then
		g_currentMission:addWarning(g_i18n:getText("MECHANIKER_SMALL_SERVICE"), 0.040, 0.035);
		g_currentMission:addHelpButtonText(g_i18n:getText("MECHANIKER_BUTTON"), InputBinding.MECHANIKER_BUTTON);
	elseif self.attachableSmallServiceWarning then
		g_currentMission:addWarning(string.format(g_i18n:getText("SMALL_SERVICE"), self.attachableSmallServicePrice + self.priceRefresherSmall), 0.040, 0.035);
		g_currentMission:addHelpButtonText(g_i18n:getText("SERVICE_BUTTON"), InputBinding.SERVICE_BUTTON);
	elseif self.attachableInspektionMechaniker then
		g_currentMission:addWarning(g_i18n:getText("MECHANIKER_INSPEKTION"), 0.040, 0.035);
		g_currentMission:addHelpButtonText(g_i18n:getText("MECHANIKER_BUTTON"), InputBinding.MECHANIKER_BUTTON);
	elseif self.attachableInspektionWarning then
		g_currentMission:addWarning(string.format(g_i18n:getText("INSPEKTION"), self.attachableInspektionPrice + self.priceRefresherInspektion), 0.040, 0.035);
		g_currentMission:addHelpButtonText(g_i18n:getText("INSPEKTION_BUTTON"), InputBinding.SERVICE_BUTTON);
	end;
end;

function attachableService:addAttachableServiceTimeBig(addTime)
	local time = math.max(Utils.getNoNil(addTime, 0), 0);
	
	self.attachableBigServiceTime = self.attachableBigServiceTime + time;
end;

function attachableService:addAttachableServiceTimeSmall(addTime)
	local time = math.max(Utils.getNoNil(addTime, 0), 0);
	
	self.attachableSmallServiceTime = self.attachableSmallServiceTime + time;
end;

function attachableService:addAttachableServiceTimeInspektion(addTime)
	local time = math.max(Utils.getNoNil(addTime, 0), 0);
	
	self.attachableInspektionTime = self.attachableInspektionTime + time;
end;

function attachableService:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local attachableBigServiceTime = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#attachableBigServiceTime"), self.attachableBigServiceTime) * 1000;
	local attachableSmallServiceTime = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#attachableSmallServiceTime"), self.attachableSmallServiceTime) * 1000;
	local attachableInspektionTime = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#attachableInspektionTime"), self.attachableInspektionTime) * 1000;
	
	self:addAttachableServiceTimeBig(attachableBigServiceTime);
	self:addAttachableServiceTimeSmall(attachableSmallServiceTime);
	self:addAttachableServiceTimeInspektion(attachableInspektionTime);
	
    return BaseMission.VEHICLE_LOAD_OK;
end;

function attachableService:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'attachableBigServiceTime="' .. tostring((self.attachableBigServiceTime / 1000)) ..'" attachableSmallServiceTime="' .. tostring((self.attachableSmallServiceTime / 1000)) ..'" attachableInspektionTime="' .. tostring((self.attachableInspektionTime / 1000)) ..'"';
	
	return attributes, nil;
end;